#include "ik_nec.h"
#include "common.h"

/*
//###########################################################################//
#define IK_N 0xFFU // unnamed china
//#define IK_N 0xDFU // LG
#define DECODER ((uint16_t)((~IK_N)<<8)|IK_N)
const uint16_t range_z[] = {
  628,1167,35,66,35,66,634,1177,0,0,
  76,278,76,278,2890,12759,798,1483,2890,12759,949,1764 };
//###########################################################################//
*/

static const uint16_t range_z[4][4] =
{
  720,1080,368,552,
  35,66,43,228,
  35,62,3200,12000,
  720,1080,184,276,
};

static struct ik_str 
{
  uint32_t stor;
  uint8_t status;
  uint8_t poz;
} ik;

void ik_tim_init(void)
{
  RCC->APB1ENR  |= RCC_APB1ENR_TIM2EN; // 2-й таймер
  RCC->AHBENR |= RCC_AHBENR_GPIOAEN;
  //GPIOA->MODER |= _VAL2FLD(GPIO_MODER_MODER6, 2); //Alternate function mode
  //GPIOA->AFR[0] |= _VAL2FLD(GPIO_AFRL_AFSEL6, 1);
  GPIOA->MODER  |= _VAL2FLD(GPIO_MODER_MODER0, 2);
  GPIOA->AFR[0] |= _VAL2FLD(GPIO_AFRL_AFSEL0, 2);
  GPIOA->LCKR = (1 << 16) | (1 << 6);
  GPIOA->LCKR = 1 << 6;
  GPIOA->LCKR = (1 << 16) | (1 << 6);
  TIM2->PSC = 950; /// 48000000 / 50526 (509us = 51L)

  TIM2->CCMR1 = _VAL2FLD(TIM_CCMR1_CC1S, 1)|
  _VAL2FLD(TIM_CCMR1_CC2S, 2);
  TIM2->CCER = _VAL2FLD(TIM_CCER_CC1P, 1)|
  _VAL2FLD(TIM_CCER_CC2P, 0)|
  _VAL2FLD(TIM_CCER_CC1E, 1)|
  _VAL2FLD(TIM_CCER_CC2E, 1);
  TIM2->SMCR = _VAL2FLD(TIM_SMCR_TS, 5)| // Filtered Timer Input 1 (TI1FP1)
  _VAL2FLD(TIM_SMCR_SMS, 4); // Reset Mode (TRGI)
  TIM2->DIER = TIM_DIER_CC1IE;
  TIM2->CR1 |= TIM_CR1_CEN;
  //NVIC_SetPriority(TIM2_IRQn, 3);
  NVIC_EnableIRQ(TIM2_IRQn);
}

void ik_tim_init_old(void)
{
  RCC->APB1ENR  |= RCC_APB1ENR_TIM2EN; // 2-й таймер
  RCC->AHBENR |= RCC_AHBENR_GPIOAEN;
  //GPIOA->MODER |= _VAL2FLD(GPIO_MODER_MODER6, 2); //Alternate function mode
  //GPIOA->AFR[0] |= _VAL2FLD(GPIO_AFRL_AFSEL6, 1);
  GPIOA->MODER  |= _VAL2FLD(GPIO_MODER_MODER0, 2);
  GPIOA->AFR[0] |= _VAL2FLD(GPIO_AFRL_AFSEL0, 2);
  GPIOA->LCKR = (1 << 16) | (1 << 6);
  GPIOA->LCKR = 1 << 6;
  GPIOA->LCKR = (1 << 16) | (1 << 6);
  TIM2->PSC = 950; /// 48000000 / 50526 (509us = 51L)

  TIM2->CCMR1 = _VAL2FLD(TIM_CCMR1_CC1S, 1)|
  _VAL2FLD(TIM_CCMR1_CC2S, 2);
  TIM2->CCER = _VAL2FLD(TIM_CCER_CC1P, 1)|
  _VAL2FLD(TIM_CCER_CC2P, 0)|
  _VAL2FLD(TIM_CCER_CC1E, 1)|
  _VAL2FLD(TIM_CCER_CC2E, 1);
  TIM2->SMCR = _VAL2FLD(TIM_SMCR_TS, 5)| // Filtered Timer Input 1 (TI1FP1)
  _VAL2FLD(TIM_SMCR_SMS, 4); // Reset Mode (TRGI)
  TIM2->DIER = TIM_DIER_CC1IE;
  TIM2->CR1 |= TIM_CR1_CEN;
  //NVIC_SetPriority(TIM14_IRQn, 4);
  NVIC_EnableIRQ(TIM2_IRQn);
}


void TIM2_IRQHandler(void) //124
{
  uint32_t stor = ik.stor;
  uint32_t status = ik.status;
  uint32_t poz = ik.poz;
  uint32_t lsi, hsi;
  TIM2->SR = 0;
  lsi = TIM2->CCR2;
  hsi = (TIM2->CCR1 - lsi);

  if ((lsi > range_z[status][0])&&(lsi < range_z[status][1])&&
      (hsi > range_z[status][2])&&(hsi < range_z[status][3]))
  {
    if (status == 1)
    {
      lsi = 116 - hsi; lsi >>= 31;
      stor = lsi | (stor << 1);
      if (++poz > 31)
      {
        ik_out = stor; status = 2;
      };
    }else if (status == 3)
    {
      ik_out = stor; status = 2;
    }else status += 1;
  }else {status = 0; poz = 0;};
  //ik_out = (uint16_t)stor;
  //pin_toggle(GPIOA, 1<<15);
  ik.stor = stor;
  ik.status = status;
  ik.poz = poz;
};

/*void TIM2_IRQHandler(void) //124
{
  uint32_t stor = ik.stor;
  uint32_t status = ik.status;
  uint32_t poz = ik.poz;
  uint32_t lsi, hsi;
  TIM2->SR = 0;
  lsi = TIM2->CCR2;
  hsi = (TIM2->CCR1 - lsi);

  if ((lsi > range_z[status][0])&&(lsi < range_z[status][1])&&
      (hsi > range_z[status][2])&&(hsi < range_z[status][3]))
  {
    if (status == 1)
    {
      lsi = 116 - hsi; lsi >>= 31;
      stor = lsi | (stor << 1);
      if (++poz > 31)
      {
        ik_out = stor; status = 2;
      };
    }else if (status == 3)
    {
      ik_out = stor; status = 2;
    }else status += 1;
  }else {status = 0; poz = 0;};

  ik.stor = stor;
  ik.status = status;
  ik.poz = poz;
};*/

/*void TIM2_IRQHandler (void) { //220
  uint32_t tmp;
  static uint8_t status = 0;
  static uint8_t poz;
  static uint32_t stor;
  if ((TIM2->SR & (TIM_SR_CC1IF | TIM_SR_CC2IF | TIM_SR_CC3IF | TIM_SR_CC4IF))
       != (TIM_SR_CC1IF | TIM_SR_CC2IF | TIM_SR_CC3IF)) goto uno;
  tmp = TIM2->CCR2;
  if (tmp < range_z[status << 1]) goto uno;
  if (tmp > range_z[(status << 1) + 1]) goto uno;
  switch (status) {
    case 0: status = 1; poz = 32; stor = 0; tmp = 10; break;
    case 1: tmp = stor << 1;
            if (TIM2->CCR1 > 170) tmp |= 1;
            stor = tmp; poz--; tmp = 12;
            if (poz == 0) {
              /// watch raw IR code
              //stor = (~IK_N<<24)|(IK_N<<16)|(~ik_out<<8)|(ik_out);
              if ((DECODER == (stor >> 16)) && ((((stor >> 8) ^ stor) & 0xFF) == 0xFF)) {
              //stor &= 0xFF;
              ik_out = stor; tmp = 14; status = 2;

              } else goto uno;
            }; break;
    case 2: status = 3; tmp = 16; break;
    case 3: status = 2; tmp = 18; ik_out = stor; break;
    default: uno: status = 0; tmp = 20; break;
    };
  TIM2->SR = 0;
  TIM2->CCR3 = range_z[tmp++];
  TIM2->CCR4 = range_z[tmp];
  //pin_toggle(GPIOA, 1<<15);
}*/